import rewiremock from 'rewiremock';
import '../../../mocks/electron';

import { expect } from 'chai';
import fs from 'fs-extra';
import 'mocha';
import path from 'path';
import { save, StoreKeys } from '../../../src/main/services/store';

const storeDirectory = path.resolve('store');
const storeBackupDirectory = path.resolve('store-backup');

describe('Store Service', function() {
  this.timeout(10000);

  before(() => {
    rewiremock.enable();
    if (fs.existsSync(storeDirectory)) {
      fs.removeSync(storeBackupDirectory);
      fs.moveSync(storeDirectory, storeBackupDirectory);
    }
  });

  after(() => {
    rewiremock.disable();
    if (fs.existsSync(storeBackupDirectory)) {
      fs.removeSync(storeDirectory);
      fs.moveSync(storeBackupDirectory, storeDirectory);
    }
  });

  it('creates a store directory', () => {
    if (fs.existsSync(storeDirectory)) {
      fs.removeSync(storeDirectory);
    }
    return save(StoreKeys.COOKIES, { some: 'data' }).then(() => {
      expect(fs.existsSync(storeDirectory)).to.be.true;
    });
  });
});
